<?php
/**
 * Класс для работы с чатом
 * 
 * @package Classes
 * @author Shamsik
 * @link http://shcms.ru
 */

class controller {
    /*
     * Обрабатываем отправленный текст
     * 
     * @param $param 
     */

    public static function comment($param) {
        global $db, $_date, $glob_core, $id_user, $error;

        //Проверка переданного $_POST
        $text = filter_input(INPUT_POST, 'text', FILTER_SANITIZE_STRING);
        //Экранируем специальные символы
        $text = $db->safesql($text);

        if (engine::trim($text) == false and empty($text)) {
            $error['text'][] = 'Сообщение не введено';
        }
        //Короткие сообщение не должны отправляться
        if (strlen($text) < 5) {
            $error['text'][] = 'Сообщение должно быть больше 5 символов';
        }
        //В сообщение не должно присутствовать мат
        if ($glob_core['antimat'] == 1) {
            $text = SwearFilter::filter($text);
        }
        //В сообщение не должен присутствовать реклама (ссылки)
        if ($glob_core['antiadv'] == 1) {
            $text = engine::antilink($text);
        }
        //Удаляем ссылки из текстов
        if ($glob_core['antilink'] == 1) {
            $text = engine::removing($text);
        }
        //Если хотябы одна ошибка найдется в $error то не допустится
        if (empty($error)) {
            //Записываем сообщение в базу
            $chat = $db->query("INSERT INTO `chat` (`text`,`time`,`id_user`)
                    VALUES ('{$text}','{$_date}','{$id_user}')");
            if ($chat == true) {
                //Начисление баллов пользователю
                user::points();
                //Переадресция после успешной отправки
                header('Location: index.php');
            } else {
                $error['text'][] = 'Сообщение не добавлено';
            }
        }
    }

    /**
     * HTML форма добавления сообщений
     * 
     * @param form()
     */

    public static function form() {
        global $error, $id_user;
        //Привелегие пользователя
        $group = user::users($id_user, array('group'));
        //Если у пользователя привилегия 15
        if ($group == 15) {
            $view = '<a href="?do=all">' . Lang::__('Удаляем все') . '</a>';
        }
        //Спойлер Кнопки для чата
        echo '<div style="margin-bottom:4px;text-align:right;">';
        //Кнопка
            echo '<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#chat">Новое сообщение</button>';
        echo '</div>';
        
        //Полученная форма
        echo '<div id="chat" class="collapse">';
        echo '<div class="mainname">' . Lang::__('Новое сообшение') . '';
        echo '<span class="time">' . $view . '</span></div>';
        echo '<div class="mainpost">';
        //HTML форма
        $form = new form('?');
        $form->textarea(false, 'text', false, (isset($error['text']) ? '<span style="color:red"><small>' . implode('<br />', $error['text']) . '</small></span><br />' : ''));
        $form->submit('Отправить', 'submit',true,'btn btn-success');
        $form->display();

        echo '</div></div>';
    }

    /**
     * Вывод всех сообщений чата
     * 
     * @param output()
     */

    public static function output() {
        global $db, $id_user;
        //Счетчик вывода сообщений По умолчанию 10
        $count = $db->get_array($db->query("SELECT COUNT(*) FROM `chat`"));
        $list = new Navigation($count[0], 10, true);
        //Если в базе есть хоть одно сообщение то выводим их все.
        if ($count[0] > 0) {
            $query = $db->query("SELECT * FROM `chat` ORDER BY `id` DESC " . $list->limit() . "");
        } else {
            echo '<div class="mainname">'.Lang::__('Не найдено ничего').'</div>';
            echo '<div class="mainpost"><center>' . Lang::__('Сообщений не найдено') . '</center></div>';
            exit;
        }

        echo '<div class="mainname">Всего постов: '.$count[0].'</div>';
        echo '<div class="mainpost">';
        echo '<div class="qa-message-list" id="wallmessages">';
        //Вывод всех сообщений
        $i = 0;
        while ($chat = $db->get_array($query)) {
            ++$i;
            //Получаем данные о пользователе
            $profile = $db->get_array($db->query("SELECT * FROM `users` WHERE `id` = '{$chat[id_user]}'"));
            //Получение данных о привилегий
            $group = user::users($id_user, array('group'));
            //Если у привилегии 15 то выполняем действие
            if ($group == 15) {
                $viewd = '<a href="?do=delete&id=' . $chat['id'] . '">';
                $viewd .= '<i style="font-size:14px;" class="glyphicon glyphicon-trash"></i></a>';
            }
            //Путь к аватарам
            $avatar = '/upload/avatar/' . $profile['avatar'];

    	    echo '<div class="message-item">';
                echo '<div class="message-inner">';
	            echo '<div class="message-head clearfix">';
                        //Получаем действующий аватар
	                echo '<div class="avatar pull-left">';
                            if ($profile['avatar'] == false and file_exists($avatar) == false) {
                                echo '<img class="Chatimg" src="/engine/template/icons/default_large.png">';
                            } else {
                                echo '<img class="Chatimg" src="' . $avatar . '">';
                            }
                        echo '</div>';
			//Данные поста					
                        echo '<div class="user-detail">';
                            //Автор добавления
		            echo '<h5 class="handle">';
                            echo '<a href="'.MODULE.'profile.php?id='.$profile['id'].'">'.$profile['nick'].'</a>';
                            echo '<span class="time">' . $viewd . '</span>';
                            echo '</h5>';
                                //Разделитель
		                echo '<div class="post-meta">';
		                    echo '<div class="asker-meta">';
			                echo '<span class="qa-message-what"></span>';
		                        echo '<span class="qa-message-when">';
			                echo '<span class="qa-message-when-data">';
                                    //Дополнительные данные    
                                    echo '<div style="border-bottom: 0px;" class="details">';
                                        //Привиление пользователя
                                        echo '<span>';
                                        echo '<img src="/engine/template/icons/group.png">&nbsp;'.user::group($chat['id_user']);
                                        echo '</span>';
                                        //Дата добавления
                                        echo '<span>';
                                        echo '<img src="/engine/template/icons/date.png">&nbsp;'.date::make_date($chat['time']);
                                        echo '</span>';
                                    echo '</div>';
                                        echo '</span>';
			                echo '</span>';		
		                    echo '</div>';
		                echo '</div>';
                            echo '</div>';
	                echo '</div>';
                        //Текст сообщения                        
		        echo '<div class="qa-message-content">'.engine::input_text($chat['text']).'</div>';
	 
                echo '</div></div>'; 
        }

        echo '</div>';
        echo '</div>';

        //Получаем постаничную навигацию
        echo $list->pagination();
        echo engine::home( array( Lang::__('Назад') , '/' ) );
    }

}