
<?php
define('SHCMS_ENGINE',true);
include_once('../engine/system/core.php');
//Заголовок
$templates->template('Регистрация посетителя');

//Если пользователь уже вошел на сайт то FALSE
if($id_user == true) {
    header('Location: /index.php');
}


switch($do):
    default:
    //Получение IP адреса гостя    
    $ip = engine::get_ip();
    //Создаем массив ошибок
    $error = array();
    //Обработка кнопки
    $submit = filter_input(INPUT_POST,'submit');
        //Если нажата кнопка
        if(isset($submit)) {
            //Обработа Полученного логина
	    $nick = filter_input( INPUT_POST, 'login', FILTER_SANITIZE_STRING );
            //Обработка полученного E-mail`a
            $email = filter_input( INPUT_POST, 'email', FILTER_SANITIZE_EMAIL );
            $email = filter_var( $email, FILTER_VALIDATE_EMAIL );
            //Обработка полученного пароля
	    $password = filter_input(INPUT_POST, 'password', FILTER_SANITIZE_STRING);
	    $password2 = filter_input(INPUT_POST, 'password2', FILTER_SANITIZE_STRING);
                //Если введенные пароли не совпадают
	        if( $password != $password2 ) {
                    $error['password'][] = 'Введенные пароли должны быть одинаковы';
                }
                //Если введенный пароль меньше 5 символов
	        if( strlen($password) < 5 ) {
                    $error['password'][] = 'Пароль должен быть выше 5 символов';
                }
                //Если Ник превышает 30 символов
	        if( engine::strlen_shcms( $nick,'utf-8' ) > 30 or engine::strlen_shcms( trim( $nick ), 'utf-8' ) < 3) {
                    $error['login'][] = 'Недопустимая длина ника';
                }
                //Проверка на недоступных символов
	        if( preg_match( "/[\||\'|\<|\>|\[|\]|\"|\!|\?|\$|\@|\/|\\\|\&\~\*\{\+]/", $nick ) ) {
                    $error['login'][] = 'Ваш ник недопустим к регистрации';
                }
                //Проверяет введено ли в начале Буквы а не Номера
		if( preg_match('/[0-9]+/',engine::format_r($nick))) {
                    $error['login'][] = 'В начале запрещено использовать числовые значение'; 
                }
                //Проверяем введенные Email
		if( empty( $email ) or strlen( $email ) > 50 OR @count( explode( '@',$email ) ) != 2 ) {
                    $error['email'][] =  'Введенный Email неверный';
                }
                //Проверяем Ник
	        if( strpos( strtolower( $nick ), '.php' ) !== false ) {
                    $error['login'][] =  'Введенный ник недопустим';
                }
                //Проверяем Ник на ограниченные ошибки
		if( stripos( urlencode($nick), '%AD') !== FALSE) {
		    $error['login'][] = 'Введенный ник недопустим';
		}
                //Срезаем ненужные пустые значение из Ника
		if( function_exists('mb_strtolower') ) {
		    $nick = mb_strtolower($nick, 'utf-8');
		} else {
		    $nick = strtolower( $nick );
		}
            //Проверям На свободность ника    
            $cnick = $db->super_query( "SELECT COUNT(*) as count FROM `users` WHERE nick = '$nick'" );
                //Выводим параметр
		if( $cnick['count'] ) {
                    $error['login'][] =  'Введенный Логин уже существует';
                }
            //Проверям на свободность почты    
	    $row = $db->super_query( "SELECT COUNT(*) as count FROM `users` WHERE email = '$email'" );
                //Выводим параметр
		if( $row['count'] ) {
                    $error['email'][] =  'Введенный Email уже существует';
                }
            //Проверяем была ли у вас раньше Регистрация на сайте    
	    $rowlog = $db->super_query( "SELECT COUNT(*) as count FROM `users` WHERE logged_ip = '{$ip}'" );
                if ( $rowlog['count'] ) {	
		 echo die(engine::error('На сайте запрещена регистрация нескольких аккаунтов в одним и тем же IP адресом'));
		}
            //Проверяем е
	    if(empty($error)) {
                //Генереруем пароль для безопастности
	        $shgen = engine::shgen($password);
                //Добавляем данные в базу
	        $db->query( "INSERT INTO `users` (`nick`,`password`,`email`,`reg_date`,`lastdate`,`group`,`logged_ip`) VALUES ('".$db->safesql($nick)."','".$shgen."','".$db->safesql($email)."','$_date','$_date','1','$ip')" );
	        //Получаем последний id
                $id = $db->insert_id();
                //Запускаем Куки и добавляем данные
		setcookie( "user_id_shcms", $id, 365 );
		setcookie( "password_shcms", $shgen, 365 );
                //Запуск Сессии и добавляем данные
		$_SESSION['user_id_shcms'] = $id;
		$_SESSION['password_shcms'] = $shgen;
		    header("Location: ../index.php");
	    }
	}
    
echo '<div class="mainname">';
echo '<img src="/engine/template/icons/info.png">&nbsp;';
echo Lang::__('Новый пользователь');
echo '</div>';
echo '<div class="mainpost">';

    $form = new form('?','','','class="form-horizontal" id="passwordForm"');
    
    $form->text('<div class="stepwizard">
    <div class="stepwizard-row">
        <div class="stepwizard-step">
            <button type="button" class="btn btn-info btn-circle">1</button>
            <p>Регистрация</p>
        </div>
        <div class="stepwizard-step">
            <button type="button" class="btn btn-default btn-circle" disabled="disabled">2</button>
            <p>Завершение</p>
        </div> 
    </div>
</div>');
    $form->text('<center><div class="text-info">Заполните все поля</div></center><br/>');
    //Логин
    $form->text('<div class="form-group">');
    $form->text('<label class="col-sm-3 control-label">Логин</label>');
    $form->text('<div class="col-sm-8">');
    $form->input2(false,'login','text',htmlspecialchars($nick),'id="login_r" class="form-control" placeholder="Введите Логин"');
    //Ошибки при регистрации Логина
    if(isset($error['login'])) {
        $form->text('<span class="text-danger small">'.implode('<br/>', $error['login']).'</span>');
    }else {
        $form->text('<span class="text-muted small">От 3 до <span id="chars_login" class="charsl">26</span> символов</span>');
    }
    $form->text('</div></div><div class="row_g"></div>');
    
    //Эл. Почта
    $form->text('<div class="form-group">');
    $form->text('<label class="col-sm-3 control-label">Email</label>');
    $form->text('<div class="col-sm-8">');
    $form->input2(false,'email','email',htmlspecialchars($email),'class="form-control" placeholder="shcms@shcms.ru"');
    //Ошибки при регистрации почты
    if(isset($error['email'])) {
        $form->text('<p class="text-danger small">'.implode('<br/>', $error['email']).'</p>');
    }else {
        $form->text('<span class="text-muted small">E-mail необходим для восстановления пароля</span>');
    }
    $form->text('</div></div><div class="row_g"></div>');
    
    //Пароль
    
    $form->text('<div class="form-group">');
    $form->text('<label class="col-sm-3 control-label">Пароль</label>');
    $form->text('<div class="col-sm-8">');
    $form->text('<div class="input-group">');
    $form->input3(false,'password','password',false,'class="form-control pwd" id="password1" placeholder="Пароль" autocomplete');   
    $form->text('<span class="input-group-btn">');
    $form->text('<button  style="margin-bottom:20px;"  class="btn btn-default reveal" type="button"><i class="glyphicon glyphicon-eye-open"></i></button>');
    $form->text('</span>  </div>');
    //Ошибки при регистрации пароля
    if(isset($error['password'])) {
        $form->text('<p class="text-danger small">'.implode('<br/>', $error['password']).'</p>');
    }else {
        //Первый блок
        $form->text('<div class="col-md-6">');
        $form->text('<span id="8char" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> 8 символов<br>');
        $form->text('<span id="ucase" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Одну заглавную букву<br/>');
        $form->text('</div>');
        //Второй блок
        $form->text('<div class="col-md-6">');
        $form->text('<span id="lcase" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Одну строчную букву<br>');
        $form->text('<span id="num" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Номерной символ');
        $form->text('</div>');
        
    }   
    $form->text('</div></div><div class="row_g"></div>');
    
    //Подтверждение пароля
    $form->text('<div class="form-group">');
    $form->text('<label class="col-sm-3 control-label">Подтверите</label>');
    $form->text('<div class="col-sm-8">');
    $form->input2(false,'password2','password',false,'class="form-control" placeholder="Подтвердите пароль" id="password2"');
    if(isset($error['password'])) {
        $form->text('<p class="text-danger small">'.implode('<br/>', $error['password']).'</p>');
    }else {
        $form->text('<div class="col-md-6">');
        $form->text('<span id="pwmatch" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Совпадение паролей');
        $form->text('</div>');
    }
    $form->text('</div></div>');
    
    //Кнопка регистрации
    $form->text('<div class="modal-footer">'); 
    $form->submit('Регистрация','submit',false,'btn btn-success');
    $form->text('<a class="btn" href="/index.php">Отмена</a>');
        $form->display();
        echo '</div></div>';

    break;
    
endswitch;
